#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <modules.h>
#include <util.h>
#include <time.h>
#include <dstring.h>
#include "version.h"
/// \section[NAME]
// \em[rand] -- a module for NSL (see \ref[sl(1)])

/// \section[OVERVIEW]

static module *this_mod;
extern procstack *get_pstack(void);
extern void define_var(interpreter *i, int status, char *name, dstring *val);

void rand_LTX_init(module *this)
{
	this_mod = this;
}

static void bi_rand(chunk *current, interpreter *i, value *args)
{
	ds_append(get_pstack()->state->buffer, ds_fromint(rand(), 10, 0));
}

static void bi_srand(chunk *current, interpreter *i, value *args)
{
	srand(args ? convert_to_int(DS_BODY(args->val)) : time(NULL));
}

static master_instruction_src rand_src_add[] = {
										 { "rand", 1, bi_rand, 0, 0, 0},
										 { "srand", 0, bi_srand, 0, 1, 1},
#ifdef HAVE_LRAND48
										 { "rand48", 1, bi_rand, 0, 0, 0},
										 { "srand48", 0, bi_srand48, 0, 0, 0},
										 { "seed48", 0, bi_seed48, 3, 3, 3},
#endif
										 {NULL}
										};

void rand_LTX_attach(mod_attach *ma)
{
	variable *v;
	append_builtins(ma->i, rand_src_add);
	define_var(ma->i, var_global, "RAND_MAX", ds_fromint(RAND_MAX, 10, 0));
	v = safe_get_var(ma->i, "RAND_MAX", 0);
	v->readonly = 1;
}

const char rand_LTX_version[] = VERSION;
const char rand_LTX_date[] = __DATE__;

/// \section[AUTHOR]

/// \section[COPYRIGHT]
// see \ref[sl(1)]

/// \seealso
